package examen.horloge;

import examen.visus.VisuHorloge;
import static org.junit.jupiter.api.Assertions.assertEquals;
import java.time.LocalTime;
import org.junit.jupiter.api.Test;

public class HorlogeTest {
  
  @Test
  void testHorloge() {
    
    Horloge horloge = new Horloge();
    horloge.start();
  }
  
  @Test
  void testAddEcouteur() {
    
    Horloge horloge = new Horloge();
    horloge.start();
    
    VisuHorloge vh = new VisuHorloge();
    horloge.ajouterEcouteur(vh);
  }
  
  @Test
  void testSuppEcouteur() {
    
    Horloge horloge = new Horloge();
    horloge.start();
    
    VisuHorloge vh = new VisuHorloge();
    horloge.ajouterEcouteur(vh);
    horloge.SuppEcouteur(vh);
  }
  
  @Test
  void testGetHeure() {
    
    Horloge horloge = new Horloge();
    horloge.start();
    
    VisuHorloge vh = new VisuHorloge();
    Heure h = new Heure(LocalTime.now());
    vh.setHeure(h);
    horloge.ajouterEcouteur(vh);
    
    Heure attendu = h;
    Heure effectif = horloge.getHeure();
    assertEquals(attendu.getHeure(), effectif.getHeure(), "attendu et effectif devraient être à la même heure");
    assertEquals(attendu.getMinute(), effectif.getMinute(), "attendu et effectif devraient être à la même minute");
    assertEquals(attendu.getSeconde(), effectif.getSeconde(), "attendu et effectif devraient être à la même seconde");
  }
}